function T = bigDAT(n,treelike)
T = RandLitTree(treelike);
[sizeT dump] = size(T);
while sizeT < n
    gate = randsample(["OR" "AND"],1);
    r1 = randi([1 2]);
    if r1 == 1
        T1 = T;
        T2 = RandLitTree(treelike);
    else
        T1 = RandLitTree(treelike);
        T2 = T;
    end
    if treelike
        r2 = randi([1 2]);
    else
        r2 = randi([1 3]);
    end
    if r2 == 1
        T = Combine_Tree(T1,T2,gate);
    elseif r2 == 2
        T = Combine_BAS(T1,T2);
    else
        T = Combine_noTree(T1,T2,gate);
    end
    [sizeT dump] = size(T);
end
if treelike
    T.Probability = zeros(sizeT,1);
    for i = 1:sizeT
        if T{i,"Type"} == "BAS"
            T{i,"Probability"} = randi([1 10])/10;
        end
    end
end
end

function T = RandLitTree(treelike)
if treelike
    r = randi([5 9]);
else
    r = randi([1 9]);
end
if r == 1
% Kumar 2015 f1 https://www.ennoruijters.nl/QATAPTA.pdf %DAT
    Name = ["b1";"b2";"s1";"b3";"b4";"b5";"s2";"b6";"s3";"o1";"b7";"s4"];
    Type = ["BAS";"BAS";"AND";"BAS";"BAS";"BAS";"AND";"BAS";"AND";"OR";"BAS";"AND"];
    Children = {[];[];["b1" "b2"];[];[];[];["b3" "b4" "b5"];[];["b3" "b4" "b6"];["s1" "s2" "s3"]; []; ["o1" "b7"]};
    T = table(Type,Children); 
    T.Properties.RowNames = Name;
    T.Cost = zeros(12,1);
    T.Damage = randi([0 10],12,1);
    for i = 1:12
        if T{i,"Type"} == "BAS"
            T{i,"Cost"} = randi([1 10]);
        end
    end
elseif r==2
% Kumar 2015 f8 https://www.ennoruijters.nl/QATAPTA.pdf %DAT
    Name = ["b1";"b2";"o1";"b3";"s1";"b4"; "b5"; "s2"; "b6"; "b7"; "s3"; "o2"; "b8"; "s4"; "o3"; "b9"; "b10"; "b11"; "o4"; "o5"];
    Type = ["BAS";"BAS";"OR";"BAS";"AND"; "BAS"; "BAS"; "AND"; "BAS"; "BAS"; "AND"; "OR"; "BAS"; "AND"; "OR"; "BAS"; "BAS"; "BAS"; "OR"; "OR"];
    Children = {[];[];["b1" "b2"];[];["b3" "o1"]; []; []; ["b3" "b4" "b5"]; []; []; ["b6" "b7"]; ["s2" "s3"]; []; ["o2" "b8"]; ["s1" "s4"]; []; []; []; ["b9" "b10" "b11"]; ["o4" "s4"]};
    T = table(Type,Children); 
    T.Properties.RowNames = Name;
    T.Cost = zeros(20,1);
    T.Damage = randi([0 10],20,1);
    for i = 1:20
        if T{i,"Type"} == "BAS"
            T{i,"Cost"} = randi([1 10]);
        end
    end
elseif r==3
% Kumar 2015 f9 https://www.ennoruijters.nl/QATAPTA.pdf %DAT
    Name = ["b1"; "b2"; "o1"; "b3"; "s1"; "b4"; "b5"; "s2"; "b6"; "b7"; "o2"; "o3"];
    Type = ["BAS"; "BAS"; "OR"; "BAS"; "AND"; "BAS"; "BAS"; "AND"; "BAS"; "BAS"; "OR"; "OR"];
    Children = {[];[]; ["b1" "b2"]; []; ["o1" "b3"]; []; []; ["b4" "b5"]; []; []; ["b3" "s2" "b6" "b7"]; ["s1" "o2"]};
    T = table(Type,Children); 
    T.Properties.RowNames = Name;
    T.Cost = zeros(12,1);
    T.Damage = randi([0 10],12,1);
    for i = 1:12
        if T{i,"Type"} == "BAS"
            T{i,"Cost"} = randi([1 10]);
        end
    end
elseif r==4
%Arnold 2015 f1
%https://link.springer.com/chapter/10.1007%2F978-3-319-24249-1_25 %DAT
    Name = ["b1"; "b2"; "b3"; "s1"; "b4"; "b5"; "s2"; "o1"; "b6"; "s3"; "b7"; "b8"; "s4"; "o2"; "b9"; "o3"];
    Type = ["BAS"; "BAS"; "BAS"; "AND"; "BAS"; "BAS"; "AND"; "OR"; "BAS"; "AND"; "BAS"; "BAS"; "AND"; "OR"; "BAS"; "OR"];
    Children = {[]; []; []; ["b1" "b2" "b3"]; []; []; ["b4" "b5"]; ["s1" "s2"]; []; ["o1" "b6"]; []; []; ["b1" "b7" "b8"]; ["s4" "s3"]; []; ["b9" "o2"]};
    T = table(Type,Children); 
    T.Properties.RowNames = Name;
    T.Cost = zeros(16,1);
    T.Damage = randi([0 10],16,1);
    for i = 1:16
        if T{i,"Type"} == "BAS"
            T{i,"Cost"} = randi([1 10]);
        end
    end
elseif r==5
%Arnold 2014 f3
%https://link.springer.com/chapter/10.1007/978-3-642-54792-8_16 %Tree
    Name = ["b1"; "b2"; "a1"; "b3"; "o1"; "b4"; "b5"; "s1"];
    Type = ["BAS"; "BAS"; "AND"; "BAS"; "OR"; "BAS"; "BAS"; "AND"];
    Children = {[]; [];["b1" "b2"]; []; ["a1" "b3"]; []; []; ["b4" "o1" "b5"]};
    T = table(Type,Children); 
    T.Properties.RowNames = Name;
    T.Cost = zeros(8,1);
    T.Damage = randi([0 10],8,1);
    for i = 1:8
        if T{i,"Type"} == "BAS"
            T{i,"Cost"} = randi([1 10]);
        end
    end
elseif r==6
%Arnold 2014 f5
%https://link.springer.com/chapter/10.1007/978-3-642-54792-8_16 %Tree
    Name = ["b1"; "b2"; "o1"; "b3"; "s1"; "b4"; "b5"; "o2"; "b6"; "o3"; "b7"; "b8"; "s2"; "o4"; "b9"; "b10"; "o5"; "b11"; "b12"; "s3"; "o6"];
    Type = ["BAS"; "BAS"; "OR"; "BAS"; "AND"; "BAS"; "BAS"; "OR"; "BAS"; "OR"; "BAS"; "BAS"; "AND"; "OR"; "BAS"; "BAS"; "OR"; "BAS"; "BAS"; "AND"; "OR"];
    Children = {[]; []; ["b1" "b2"]; []; ["o1" "b3"]; []; []; ["b4" "b5"]; []; ["b6" "o2"]; []; []; ["b7" "b8"]; ["o3" "s2"]; []; []; ["b9" "b10"]; []; []; ["b11" "o5" "b12"]; ["s1" "o4" "s3"]};
    T = table(Type,Children); 
    T.Properties.RowNames = Name;
    T.Cost = zeros(21,1);
    T.Damage = randi([0 10],21,1);
    for i = 1:21
        if T{i,"Type"} == "BAS"
            T{i,"Cost"} = randi([1 10]);
        end
    end
elseif r==7
%Arnold 2014 f7
%https://link.springer.com/chapter/10.1007/978-3-642-54792-8_16 %Tree
    Name = ["b1"; "b2"; "b3"; "o1"; "b4"; "b5"; "o2"; "b6"; "b7"; "o3"; "s1"; "b8"; "s2"; "b9"; "b10"; "s3"; "b11"; "b12"; "s4"; "o4"; "b13"; "s5"; "b14"; "s6"; "s7"];
    Type = ["BAS"; "BAS"; "BAS"; "OR"; "BAS"; "BAS"; "OR"; "BAS"; "BAS"; "OR"; "AND"; "BAS"; "AND"; "BAS"; "BAS"; "AND"; "BAS"; "BAS"; "AND"; "OR"; "BAS"; "AND"; "BAS"; "AND"; "AND"];
    Children = {[]; []; []; ["b1" "b2" "b3"]; []; []; ["b4" "o1" "b5"]; []; []; ["b6" "b7"]; ["o3" "o2"]; []; ["b8" "s1"]; []; []; ["b9" "b10"]; []; []; ["b11" "b12"]; ["s3" "s4"]; []; ["b13" "o4"]; []; ["s5" "b14"]; ["s2" "s6"]};
    T = table(Type,Children); 
    T.Properties.RowNames = Name;
    T.Cost = zeros(25,1);
    T.Damage = randi([0 10],25,1);
    for i = 1:25
        if T{i,"Type"} == "BAS"
            T{i,"Cost"} = randi([1 10]);
        end
    end
elseif r==8
%Fraile 2016 f2
%https://link.springer.com/chapter/10.1007/978-3-319-48393-1_24 %Tree
    Name = ["b1"; "b2"; "o1"; "b3"; "b4"; "b5"; "o2"; "o3"; "b6"; "o4"; "b7"; "b8"; "b9"; "o5"; "b10"; "b11"; "o6"; "b12"; "s1"];
    Type = ["BAS"; "BAS"; "OR"; "BAS"; "BAS"; "BAS"; "OR"; "OR"; "BAS"; "OR"; "BAS"; "BAS"; "BAS"; "OR"; "BAS"; "BAS"; "OR"; "BAS"; "AND"];
    Children = {[]; []; ["b1" "b2"]; []; []; []; ["b3" "b4" "b5"]; ["o1" "o2"]; []; ["b6" "o3"]; []; []; []; ["b7" "b8" "b9"]; []; []; ["b10" "b11"]; []; ["o4" "b12" "o5" "o6"]};
    T = table(Type,Children); 
    T.Properties.RowNames = Name;
    T.Cost = zeros(19,1);
    T.Damage = randi([0 10],19,1);
    for i = 1:19
        if T{i,"Type"} == "BAS"
            T{i,"Cost"} = randi([1 10]);
        end
    end
else
% Kordy 2018
% https://www.researchgate.net/publication/324514989_On_Quantitative_Analysis_of_Attack-Defense_Trees_with_Repeated_Labels
% %Tree
    Name = ["b1"; "b2"; "o1"; "b3"; "b4"; "s1"; "b5"; "b6"; "o2"; "b7"; "b8"; "o3"; "a1"; "b9"; "s2"; "o4"];
    Type = ["BAS"; "BAS"; "OR"; "BAS"; "BAS"; "AND"; "BAS"; "BAS"; "OR"; "BAS"; "BAS"; "OR"; "AND"; "BAS"; "AND"; "OR"]; 
    Children = {[]; []; ["b1" "b2"]; []; []; ["o1" "b3" "b4"]; []; []; ["b5" "b6"]; []; []; ["b7" "b8"]; ["o2" "o3"]; []; ["a1" "b9"]; ["s1" "s2"]};
    T = table(Type,Children); 
    T.Properties.RowNames = Name;
    T.Cost = zeros(16,1);
    T.Damage = randi([0 10],16,1);
    for i = 1:16
        if T{i,"Type"} == "BAS"
            T{i,"Cost"} = randi([1 10]);
        end
    end
end
end